libgdamm Reference Documentation

Main Page Namespaces Book

# Gnome::Gda::DataModel Class Reference
[Data Models]

Abstract DataModel (Base class for all DataModels). More...

Inheritance diagram for Gnome::Gda::DataModel:

[legend]
List of all members.

## Public Member Functions

bool | append_row ()
| Appends a row to the data model.
int | append_values (const ValueList& values)
| Appends a row to the given data model.
Glib::RefPtr<DataModelIter> | create_iter ()
| Creates a new iterator object Gda::DataModelIter object which can be used to iterate through rows in model.
Glib::RefPtr<const Column> | describe_column (int col) const
| Queries the underlying data model implementation for a description of a given column.
Glib::RefPtr<Column> | describe_column (int col)
| Queries the underlying data model implementation for a description of a given column.
void | dump (FILE* to_stream) const
| Dumps a textual representation of the model to the to_stream stream.
Glib::ustring | dump_as_string () const
| Dumps a textual representation of the model into a new string.
bool | export_to_file (DataModelIOFormat format, const std::string& file, const Glib::ArrayHandle<int>& cols, const Glib::ArrayHandle<int>& rows, const Glib::RefPtr<ParameterList>& options)
| Exports data contained in model to the file; the format is specified using the format argument.
Glib::ustring | export_to_string (DataModelIOFormat format, const Glib::ArrayHandle<int>& cols, const Glib::ArrayHandle<int>& rows, const Glib::RefPtr<ParameterList>& options)
| Exports data contained in model to the a string; the format is specified using the format argument.
void | freeze ()
| Disables notifications of changes on the given data model.
DataModelAccessFlags | get_access_flags () const
| Get the attributes of model such as how to access the data it contains if it's modifiable, etc.
ValueAttribute | get_attributes_at (int col, int row)
| Get the attributes of the value stored at (row, col) in proxy, which is an ORed value of Gda::ValueAttribute flags.
int | get_column_index (const Glib::ustring& name) const
| Get the index of the column named name in model.
Glib::ustring | get_column_title (int col) const

Parameters:

  | col | Column number.

int | get_n_columns () const

Returns:
  The number of columns in the given data model.

int | get_n_rows () const

Returns:
  The number of rows in the given data model, or -1 if the number of rows is not known.

int | get_row_from_values (const ValueSList& values, const Glib::ArrayHandle<int>& cols_index)
| Returns: the requested row number, of -1 if not found.
Value | get_value_at (const Glib::ustring& column_name, int row) const
Value | get_value_at (int col, int row) const
const GdaDataModel* | gobj () const
| Provides access to the underlying C GObject.
GdaDataModel* | gobj ()
| Provides access to the underlying C GObject.
bool | import_from_file (const std::string& file, GHashTable* cols_trans, const Glib::RefPtr<const ParameterList>& options)
| Imports data contained in the file file into model; the format is detected.
bool | import_from_model (const Glib::RefPtr<DataModel>& from, bool overwrite, GHashTable* cols_trans)
| Copy the contents of the from data model to the to data model.
bool | import_from_string (const Glib::ustring& string, GHashTable* cols_trans, const Glib::RefPtr<const ParameterList>& options)
| Loads the data from string into model.
bool | is_updatable () const
| Tells if model can be modified.
bool | move_iter_at_row_default (const Glib::RefPtr<DataModelIter>& iter, int row)
bool | move_iter_next_default (const Glib::RefPtr<DataModelIter>& iter)
bool | move_iter_prev_default (const Glib::RefPtr<DataModelIter>& iter)
bool | remove_row (int row)
| Removes a row from the data model.
void | send_hint (DataModelHint hint, const Value& hint_value)
| Sends a hint to the data model.
void | set_column_title (int col, const Glib::ustring& title)
| Sets the title of the given col in model.
bool | set_value_at (int col, int row, const Value& value)

Parameters:

  | col | Column number.

bool | set_values (int row, const ValueList& values)
| If any value in values is actually `0`, then it is considered as a default value.
void | signal_emit_changed ()
| Notifies listeners of the given data model object of changes in the underlying data.
Glib::SignalProxy0<void> | signal_reset ()

Prototype:
  `void on_my_reset()`

Glib::SignalProxy1< void, int > | signal_row_inserted ()

Prototype:
  `void on_my_row_inserted(int row)`

Glib::SignalProxy1< void, int > | signal_row_removed ()

Prototype:
  `void on_my_row_removed(int row)`

Glib::SignalProxy1< void, int > | signal_row_updated ()

Prototype:
  `void on_my_row_updated(int row)`

void | thaw ()
| Re-enables notifications of changes on the given data model.
virtual | ~DataModel ()

## Static Public Member Functions

static void | add_interface (GType gtype_implementer)

## Protected Member Functions

virtual void | on_reset ()
virtual void | on_row_inserted (int row)
virtual void | on_row_removed (int row)
virtual void | on_row_updated (int row)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr<Gnome::Gda::DataModel> | wrap (GdaDataModel* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Abstract DataModel (Base class for all DataModels).

A DataModel represents an array of values organized in rows and columns. All the data in the same column have the same type, and all the data in each row have the same semantic meaning. The DataModel is actually an interface implemented by other objects to support various kinds of data storage and operations.

Depending on the real implementation, the contents of data models may be modified by the user by using functions provided by the model. The actual operations that a data model permits can be discovered using the get_access_flags() method.

Again, depending on the real implementation, data retreival can be done either by accessing direct random values located by their row and column, or by using a DataModelIter cursor, or both. Use the get_access_flags() method to discover how the data model can be accessed. Note that a Datamodel which can be accessed in a random way can also be accessed using cursors (and several cusrors may be used at the same time), whereas a data model which can only be accessed using cursors can only have one cursor for iterating.

Random access data models are easier to use since picking a value is very simple by using the get_value_at(), but they consume more memory since all the accessible values must generally be present in memory even if they are not used. Thus, if a data model must handle large quantities of data, it is generally wiser to use a data model which can be only accessed using a cursor.

As a side note there are also data models which wrap other data models such as:

- The DataProxy data model which stores temporary modifications and shows only some parts of the wrapped data model.
- The DataAccessWrapper data model which offers memory-efficient random access on top of a wrapped cursor based access data model.

## Constructor & Destructor Documentation

virtual Gnome::Gda::DataModel::~DataModel | ( |  | ) | `[virtual]`

## Member Function Documentation

static void Gnome::Gda::DataModel::add_interface | ( | GType | gtype_implementer | ) | `[static]`

bool Gnome::Gda::DataModel::append_row | ( |  | ) |

Appends a row to the data model.

Returns:
  The number of the added row, or -1 if an error occurred.

int Gnome::Gda::DataModel::append_values | ( | const ValueList & | values | ) |

Appends a row to the given data model.

If any value in values is actually `0`, then it is considered as a default value.

Parameters:

  | values | List of Value* representing the row to add. The length must match model's column count. These Value are value-copied (the user is still responsible for freeing them).

Returns:
  The number of the added row, or -1 if an error occurred.

Glib::RefPtr<DataModelIter> Gnome::Gda::DataModel::create_iter | ( |  | ) |

Creates a new iterator object Gda::DataModelIter object which can be used to iterate through rows in model.

The row the returned Gda::DataModelIter represents is undefined. For models which can be accessed randomly the correspoding row can be set using gda_data_model_move_iter_at_row(), and for models which are accessible sequentially only then the first row will be fetched using gda_data_model_move_iter_next().

Returns:
  A new Gda::DataModelIter object, or `0` if an error occurred.

Glib::RefPtr<const Column> Gnome::Gda::DataModel::describe_column | ( | int | col | ) | const

Queries the underlying data model implementation for a description of a given column.

That description is returned in the form of a Gda::Column structure, which contains all the information about the given column in the data model.

WARNING: the returned Gda::Column object belongs to the model model and and should not be destroyed; any modification will impact the whole data model.

Parameters:

  | col | Column number.

Returns:
  The description of the column.

Glib::RefPtr<Column> Gnome::Gda::DataModel::describe_column | ( | int | col | ) |

Queries the underlying data model implementation for a description of a given column.

That description is returned in the form of a Gda::Column structure, which contains all the information about the given column in the data model.

WARNING: the returned Gda::Column object belongs to the model model and and should not be destroyed; any modification will impact the whole data model.

Parameters:

  | col | Column number.

Returns:
  The description of the column.

void Gnome::Gda::DataModel::dump | ( | FILE * | to_stream | ) | const

Dumps a textual representation of the model to the to_stream stream.

Parameters:

  | to_stream | Where to dump the data model.

Glib::ustring Gnome::Gda::DataModel::dump_as_string | ( |  | ) | const

Dumps a textual representation of the model into a new string.

Returns:
  A new string.

bool Gnome::Gda::DataModel::export_to_file | ( | DataModelIOFormat | format,
|  | const std::string & | file,
|  | const Glib::ArrayHandle< int > & | cols,
|  | const Glib::ArrayHandle< int > & | rows,
|  | const Glib::RefPtr<ParameterList>& | options |
| ) |  |  |

Exports data contained in model to the file; the format is specified using the format argument.

Specifically, the parameters in the list can be:

- SEPARATOR: a string value of which the first character is used as a separator in case of CSV export. -"NAME: a string value used to name the exported data if the export format is XML.
- OVERWRITE: a boolean value which tells if the file must be over-written if it already exists.

Parameters:

  | format | The format in which to export data.
  | file | The filename to export to.
  | cols | An array containing which columns of will be exported.
  | rows | An array containing which rows of will be exported.
  | options | List of options for the export.

Returns:
  true if no error occurred.

Glib::ustring Gnome::Gda::DataModel::export_to_string | ( | DataModelIOFormat | format,
|  | const Glib::ArrayHandle< int > & | cols,
|  | const Glib::ArrayHandle< int > & | rows,
|  | const Glib::RefPtr<ParameterList>& | options |
| ) |  |  |

Exports data contained in model to the a string; the format is specified using the format argument.

Specifically, the parameters in the list can be:

- SEPARATOR: a string value of which the first character is used as a separator in case of CSV export. -"NAME: a string value used to name the exported data if the export format is XML.
- OVERWRITE: a boolean value which tells if the file must be over-written if it already exists.

Parameters:

  | format | The format in which to export data.
  | cols | An array containing which columns of will be exported.
  | rows | An array containing which rows of will be exported.
  | options | List of options for the export.

Returns:
  The string.

void Gnome::Gda::DataModel::freeze | ( |  | ) |

Disables notifications of changes on the given data model.

To re-enable notifications again, you should call the gda_data_model_thaw function.

DataModelAccessFlags Gnome::Gda::DataModel::get_access_flags | ( |  | ) | const

Get the attributes of model such as how to access the data it contains if it's modifiable, etc.

Returns:
  An ORed value of Gda::DataModelAccessFlags flags.

ValueAttribute Gnome::Gda::DataModel::get_attributes_at | ( | int | col,
|  | int | row |
| ) |  |  |

Get the attributes of the value stored at (row, col) in proxy, which is an ORed value of Gda::ValueAttribute flags.

As a special case, if row is -1, then the attributes returned correspond to a "would be" value if a row was added to model.

Parameters:

  | col | A valid column number.
  | row | A valid row number, or -1.

Returns:
  The attributes as an ORed value of Gda::ValueAttribute.

int Gnome::Gda::DataModel::get_column_index | ( | const Glib::ustring & | name | ) | const

Get the index of the column named name in model.

Parameters:

  | name | A column name.

Returns:
  The column index, or -1 if no column named name was found.

Glib::ustring Gnome::Gda::DataModel::get_column_title | ( | int | col | ) | const

Parameters:

  | col | Column number.

Returns:
  The title for the given column in a data model object.

int Gnome::Gda::DataModel::get_n_columns | ( |  | ) | const

Returns:
  The number of columns in the given data model.

int Gnome::Gda::DataModel::get_n_rows | ( |  | ) | const

Returns:
  The number of rows in the given data model, or -1 if the number of rows is not known.

int Gnome::Gda::DataModel::get_row_from_values | ( | const ValueSList & | values,
|  | const Glib::ArrayHandle< int > & | cols_index |
| ) |  |  |

Returns: the requested row number, of -1 if not found.

Parameters:

  | values | A list of Value values.
  | cols_index | An array of `int` containing the column number to match each value of values.

Returns:
  The requested row number, of -1 if not found.

Value Gnome::Gda::DataModel::get_value_at | ( | const Glib::ustring & | column_name,
|  | int | row |
| ) |  |  | const

Value Gnome::Gda::DataModel::get_value_at | ( | int | col,
|  | int | row |
| ) |  |  | const

const GdaDataModel* Gnome::Gda::DataModel::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gnome::Gda::DataModelArray, Gnome::Gda::DataModelFilterSQL, Gnome::Gda::DataModelHash, Gnome::Gda::DataModelImport, Gnome::Gda::DataModelQuery, Gnome::Gda::DataModelRow, and Gnome::Gda::DataProxy.

GdaDataModel* Gnome::Gda::DataModel::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gnome::Gda::DataModelArray, Gnome::Gda::DataModelFilterSQL, Gnome::Gda::DataModelHash, Gnome::Gda::DataModelImport, Gnome::Gda::DataModelQuery, Gnome::Gda::DataModelRow, and Gnome::Gda::DataProxy.

bool Gnome::Gda::DataModel::import_from_file | ( | const std::string & | file,
|  | GHashTable * | cols_trans,
|  | const Glib::RefPtr<const ParameterList>& | options |
| ) |  |  |

Imports data contained in the file file into model; the format is detected.

Parameters:

  | file | The filename to import from.
  | cols_trans | A HashTable for columns translating, or `0`.
  | options | List of options for the export.

Returns:
  `true` if no error occurred.

bool Gnome::Gda::DataModel::import_from_model | ( | const Glib::RefPtr<DataModel>& | from,
|  | bool | overwrite,
|  | GHashTable * | cols_trans |
| ) |  |  |

Copy the contents of the from data model to the to data model.

The copy stops as soon as an error orrurs.

The cols_trans is a hash table for which keys are to columns numbers and the values are the corresponding column numbers in the from data model. To set the values of a column in to to `0`, create an entry in the hash table with a negative value.

Parameters:

  | from | The source Gda::DataModel.
  | overwrite | `true` if to is completely overwritten by from's data, and `false` if from's data is appended to to.
  | cols_trans | A HashTable for columns translating, or `0`.

Returns:
  `true` if no error occurred.

bool Gnome::Gda::DataModel::import_from_string | ( | const Glib::ustring & | string,
|  | GHashTable * | cols_trans,
|  | const Glib::RefPtr<const ParameterList>& | options |
| ) |  |  |

Loads the data from string into model.

Parameters:

  | string | The string to import data from.
  | cols_trans | A hash table containing which columns of model will be imported, or `0` for all columns.
  | options | List of options for the export.

Returns:
  `true` if no error occurred.

bool Gnome::Gda::DataModel::is_updatable | ( |  | ) | const

Tells if model can be modified.

Returns:
  `true` if model can be modified.

bool Gnome::Gda::DataModel::move_iter_at_row_default | ( | const Glib::RefPtr<DataModelIter>& | iter,
|  | int | row |
| ) |  |  |

bool Gnome::Gda::DataModel::move_iter_next_default | ( | const Glib::RefPtr<DataModelIter>& | iter | ) |

bool Gnome::Gda::DataModel::move_iter_prev_default | ( | const Glib::RefPtr<DataModelIter>& | iter | ) |

virtual void Gnome::Gda::DataModel::on_reset | ( |  | ) | `[protected, virtual]`

virtual void Gnome::Gda::DataModel::on_row_inserted | ( | int | row | ) | `[protected, virtual]`

virtual void Gnome::Gda::DataModel::on_row_removed | ( | int | row | ) | `[protected, virtual]`

virtual void Gnome::Gda::DataModel::on_row_updated | ( | int | row | ) | `[protected, virtual]`

bool Gnome::Gda::DataModel::remove_row | ( | int | row | ) |

Removes a row from the data model.

Parameters:

  | row | The row number to be removed.

Returns:
  `true` if successful, `false` otherwise.

void Gnome::Gda::DataModel::send_hint | ( | DataModelHint | hint,
|  | const Value& | hint_value |
| ) |  |  |

Sends a hint to the data model.

The hint may or may not be handled by the data model, depending on its implementation

Parameters:

  | hint | A hint to send to the model.
  | hint_value | An optional value to specify the hint, or `0`.

void Gnome::Gda::DataModel::set_column_title | ( | int | col,
|  | const Glib::ustring & | title |
| ) |  |  |

Sets the title of the given col in model.

Parameters:

  | col | Column number.
  | title | Title for the given column.

bool Gnome::Gda::DataModel::set_value_at | ( | int | col,
|  | int | row,
|  | const Value& | value |
| ) |  |  |

Parameters:

  | col | Column number.

Parameters:

  | row | Row number.
  | value | A Value, or `0`.

Returns:
  `true` if the value in the data model has been updated and no error occurred.

bool Gnome::Gda::DataModel::set_values | ( | int | row,
|  | const ValueList & | values |
| ) |  |  |

If any value in values is actually `0`, then it is considered as a default value.

Parameters:

  | row | Row number.
  | values | A list of Value, one for each n (<nb_cols) columns of model.

Returns:
  `true` if the value in the data model has been updated and no error occurred.

void Gnome::Gda::DataModel::signal_emit_changed | ( |  | ) |

Notifies listeners of the given data model object of changes in the underlying data.

Listeners usually will connect themselves to the "changed" signal in the Gda::DataModel class, thus being notified of any new data being appended or removed from the data model.

Glib::SignalProxy0< void > Gnome::Gda::DataModel::signal_reset | ( |  | ) |

Prototype:
  `void on_my_reset()`

Glib::SignalProxy1< void,int > Gnome::Gda::DataModel::signal_row_inserted | ( |  | ) |

Prototype:
  `void on_my_row_inserted(int row)`

Glib::SignalProxy1< void,int > Gnome::Gda::DataModel::signal_row_removed | ( |  | ) |

Prototype:
  `void on_my_row_removed(int row)`

Glib::SignalProxy1< void,int > Gnome::Gda::DataModel::signal_row_updated | ( |  | ) |

Prototype:
  `void on_my_row_updated(int row)`

void Gnome::Gda::DataModel::thaw | ( |  | ) |

Re-enables notifications of changes on the given data model.

## Friends And Related Function Documentation

Glib::RefPtr<Gnome::Gda::DataModel> wrap | ( | GdaDataModel * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- datamodel.h